<?php
/*********************************************************************************/
/*     Copyright (C) 2004-2005 Jean-Sbastien H. ( ED ) ( Livebox-script.com )   */
/*                                                                               */
/*     This file is part of Uptime Script                                        */
/*                                                                               */
/*     Uptime Script is free software; you can redistribute it and/or modify     */
/*     it under the terms of the GNU General Public License as published by      */
/*     the Free Software Foundation; either version 2 of the License, or         */
/*     (at your option) any later version.                                       */
/*                                                                               */ 
/*     Uptime Script is distributed in the hope that it will be useful,          */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */ 
/*     GNU General Public License for more details.                              */
/*                                                                               */
/*     You should have received a copy of the GNU General Public License         */ 
/*     along with Uptime Script; if not, write to the Free Software              */
/*     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA */
/*                                                                               */
/*********************************************************************************/
/*                                                                               */
/*         Fichier log.php                                                       */
/*         Cr le 12 dc. 06                                                    */
/*                                                                               */
/*********************************************************************************/

 abstract class AbstractSQL {
 	
    public $count_query; // Compteur qui compte le nombre de requete
    public $array_temp; // array qui contient toutes les requetes excut dans la page qui vient d'etre excut
    private $aff_error; // Booleen, affichage ou non des erreurs
    private $file_path; // Le chemin d'aces au dossier logs
    private $connexion;

    function __construct($hote,$user,$pass,$dbname,$file_path= './logs/',$aff_error = false )
    {
         $this->count_query = 0;
         $this->array_temp = array();
         $this->file_path = $file_path;         
         $this->aff_error = $aff_error;
         
         $this->connect($hote,$user,$pass);
         $this->select_bdd($dbname);
    }
    
	public abstract function connect($serveur,$login,$pass);

    public abstract function select_bdd($bdd);
	     
    public abstract function query($sql);

	public abstract function query_num($sql);

    public abstract function num_ligne($req);

    public abstract function array_sql($req,$type='assoc');
 
    public function query_array($sql,$type='assoc') {
         $req = $this->query($sql);
         return $this->array_sql($req,$type);
    }
 
 
    public function query_array_plus($req,$type='assoc')
    {
         $req = $this->query($req);
         $result = array();
         while($temp = $this->array_sql($req,$type))
         {
              $result[] = $temp;
         }
         return $result;
    }

    public function log($mess)
    {
         $fp = @fopen($this->file_path.date("d-m-Y").".txt",'a');
         if(!$fp): echo "Impossible d'acceder au fichier log: ".$this->file_path; exit(); endif;
		 $this->connexion_error = TRUE;
         fputs($fp,date("d/m/Y H:i:s")." => ".$_SERVER['SCRIPT_NAME']."\r\n ".$mess."\r\n\r\n");
         fclose($fp);
         if($this->aff_error == true): echo $mess; endif;
    }
    
    /************************************************/
    /*				LES REQUETES					*/
    /************************************************/
    
    /*
	* Requete d'enregistrement
     * @param{Array} tableau des valeurs
     */
    public function rq_doLog($table,$array) {
		$rq = sprintf("INSERT INTO `%s` SET ",mysql_real_escape_string($table));
		$i=0;
		foreach($array as $key=>$value) {
			$rq = sprintf($rq." `%s` = '%s'",mysql_real_escape_string($key),mysql_real_escape_string($value));
			$i++;
			if($i <= count($array) -1) $rq = $rq.=" , ";
		}
		return $rq;
    } // fin rq_doLog()
    
    /*
     * Chercher tous les jours enregistrs
     * @return{string}
     */
    public function rq_getAllDays() {
		 return "SELECT DISTINCT `day` FROM `log` ORDER BY `day` DESC";
    } // fin rq_getAllDays()

	/*
	 * Chercher tous les enregistrements au jour j.
	 * @param{int} $day: le timestamp du jour concern.
	 * @return{string} 
	 */
    public function rq_getFromDay($day) {
		 return sprintf("SELECT * FROM `log` WHERE `day` = %d",$day);
    } // fin rq_getFromDay()   
 
    

	/*
	 * Requete de rcupration des enregistrements des dernires 24 heures
	 * @return{string}
	 */	
    public function rq_getLast24() {
		$min = intval(date('i')/15)*15;
		$yesterday = mktime(date('H'),0,0,date('m'),date('d')-1,date('Y'));
		$today = mktime(date('H'),$min,0,date('m'),date('d'),date('Y'));
		return sprintf("SELECT * FROM `log` WHERE `time` >= %d AND `time` < %d",$yesterday,$today);
    } // fin rq_getLast24()         
    
     	
 }
?>
