<?php
/*********************************************************************************/
/*     Copyright (C) 2004-2005 Jean-Sbastien H. ( ED ) ( Livebox-script.com )   */
/*                                                                               */
/*     This file is part of Uptime Script                                        */
/*                                                                               */
/*     Uptime Script is free software; you can redistribute it and/or modify     */
/*     it under the terms of the GNU General Public License as published by      */
/*     the Free Software Foundation; either version 2 of the License, or         */
/*     (at your option) any later version.                                       */
/*                                                                               */ 
/*     Uptime Script is distributed in the hope that it will be useful,          */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */ 
/*     GNU General Public License for more details.                              */
/*                                                                               */
/*     You should have received a copy of the GNU General Public License         */ 
/*     along with Uptime Script; if not, write to the Free Software              */
/*     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA */
/*********************************************************************************/
/*                                                                               */
/*         Fichier Inventel.php                                       */
/*         Cr le 29 aout 2006                                                  */
/*                                                              				 */
/*         Derniere modification: 13sept 2006   - v4.0.0.alpha-rev10            */
/*                                                                               */
/*********************************************************************************/

require('AbstractLivebox.php');
class Livebox extends AbstractLivebox {

	protected $livebox = "Inventel";
	
	protected function loadData($ip,$user,$passwd) {
		$this->data = htmlentities(@file_get_contents("http://".$user.":".$passwd."@".$ip."/statsadsl.html"));
		$this->data .= htmlentities(@file_get_contents("http://".$user.":".$passwd."@".$ip."/info.html"));
		$this->data .= htmlentities(@file_get_contents("http://".$user.":".$passwd."@".$ip."/srv_phone.html"));
		$this->data .= htmlentities(@file_get_contents("http://".$user.":".$passwd."@".$ip."/testinfo.html"));
	}

	public function getFirmware() {
		return $this->strAnalyser($this->data,"/(v[0-9]\.[0-9]+\.[0-9]+-fr)/");
	}
	
	public function getUptime() {
		return $this->calculerUptime($this->data);
	}
	public function getCRC() {
		return $this->strAnalyser($this->data,"/ADSL_RSCORR=([0-9]*)/");
	}
	
	public function getCRC_UNCORR() {
		return $this->strAnalyser($this->data,"/ADSL_RSUNCORR=([0-9]*)/");
	}
	
	public function getCRC_UP() {
		return $this->strAnalyser($this->data,"/ADSL_RSCORR_UP=([0-9]*)/");
	}
	
	public function getCRC_UNCORR_UP() {
		return $this->strAnalyser($this->data,"/ADSL_RSUNCORR_UP=([0-9]*)/");
	}
		
	public function getIP() {
		return $this->strAnalyser($this->data,"/IP[^0-9]*([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3})/");
	}
	
	public function getSNR() {
		return $this->strAnalyser($this->data,"/ADSL_NOISE_MARGIN=([0-9]*[\.]{0,1}[0-9]*)/");
	}
	
	public function getAttenuation() {
		return $this->strAnalyser($this->data,"/ADSL_ATTENUATION=([0-9]*[\.]{0,1}[0-9]*)/");
	}
	
	public function getSNR_UP() {
		return $this->strAnalyser($this->data,"/ADSL_NOISE_MARGIN_UP=([0-9]*[\.]{0,1}[0-9]*)/");
	}
	
	public function getAttenuation_UP() {
		return $this->strAnalyser($this->data,"/ADSL_ATTENUATION_UP=([0-9]*[\.]{0,1}[0-9]*)/");
	}
	
	public function getDownload() {
		return $this->strAnalyser($this->data,"/ADSL_DOWNSTREAM=([0-9]*)/");
	}
	
	public function getAttainableDownStream() {
		return $this->strAnalyser($this->data,"/ADSL_ATTAINABLE=([0-9]*)/");
	}
	
	public function getUpload() {
		return $this->strAnalyser($this->data,"/ADSL_UPSTREAM=([0-9]*)/");
	}
	
	public function getAttainableUpStream() {
		return $this->strAnalyser($this->data,"/ADSL_ATTAINABLE_UP=([0-9]*)/");
	}
	
	public function getVoIP() {
		return $this->strAnalyser($this->data,"/voipstatus[^0-9]*([0-9])/");
	}
	
	public function getStreamOnInterface($interface) {
		$pattern = sprintf("/%s[^0-9]*([0-9]*)[^0-9]*([0-9]*)/",$interface);

		$tmp = preg_match($pattern, $this->data,$matches);

		if($tmp != 0)
			return array($matches[1],$matches[2]);
		else return NULL;
	}

	protected function calculerUptime($str) {	
	  	if(preg_match("/time[^0-9]*([0-9]*) (?:jour|jours) ([0-9]*) (?:heure|heures) ([0-9]*) (?:minute|minutes)/", $str,$matches) != 0)
	  		return (($matches[1]*24 + $matches[2])*60+$matches[3]);
	  	elseif(preg_match("/time[^0-9]*([0-9]*) (?:jour|jours) ([0-9]*) (?:heure|heures)/", $str,$matches) != 0)
	  		return ($matches[1]*24*60+$matches[2]*60);	  	
		elseif(preg_match("/time[^0-9]*([0-9]*) (?:jour|jours) ([0-9]*) (?:minute|minutes)/", $str,$matches) != 0)
	  		return ($matches[1]*24*60+$matches[2]);	  		
        elseif(preg_match("/time[^0-9]*([0-9]*) (?:jour|jours)/", $str,$matches) != 0)
	  		return $matches[1]*24*60;
        elseif(preg_match("/time[^0-9]*([0-9]*) (?:heure|heures) ([0-9]*) (?:minute|minutes)/", $str,$matches) != 0)
	  		return ($matches[1]*60+$matches[2]);			
        elseif(preg_match("/time[^0-9]*([0-9]*) (?:heure|heures)/", $str,$matches) != 0)
	  		return $matches[1]*60;	  		 
        elseif(preg_match("/time[^0-9]*([0-9]*) (?:minute|minutes)/", $str,$matches) != 0)
	  		return $matches[1];
		return 0;										 
	}
}
?>