<?php
/********************************************************************************/
/*     Copyright (C) 2004-2005 Jean-Sbastien H. ( ED ) ( Livebox-script.com )   			*/
/*                                                                               								*/
/*     This file is part of Uptime Script                                       						*/
/*                                                                               								*/
/*     Uptime Script is free software; you can redistribute it and/or modify     			*/
/*     it under the terms of the GNU General Public License as published by      			*/
/*     the Free Software Foundation; either version 2 of the License, or         			*/
/*     (at your option) any later version.                                      						*/
/*                                                                              								*/
/*     Uptime Script is distributed in the hope that it will be useful,         				*/
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of          		*/
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             	*/
/*     GNU General Public License for more details.                              					*/
/*                                                                               								*/
/*     You should have received a copy of the GNU General Public License         			*/
/*     along with Uptime Script; if not, write to the Free Software              				*/
/*     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA 		*/
/********************************************************************************/
/*                                                                              								*/
/*         Fichier day.php            	              	            							*/
/*         Cr le 23 sept 2006                         	                    						*/
/*                                                              									*/
/*         Derniere modification: 23 sept 2006   - v4.0.0.alpha-rev11           				*/
/*                                                                               								*/
/********************************************************************************/
require("libraries/DataStruct.php");
require("libraries/Analyseur.php");

class Page extends AbstractPage {

	public function displayContent() {
	
		$toDisplay = "";
		if(isset($_GET['day'])) {
			// On charge toutes les valeurs
    		$day = explode("-",trim($_GET['day']));
    		$timestamp= mktime(0,0,0,$day[1],$day[2],$day[0]);
			$result =$GLOBALS['SQL']->query($GLOBALS['SQL']->rq_getFromDay($timestamp));
			$data = new DataStruct();
			$data->buildFromSQLResult($result,false);				

			$daybefore = strtotime("-1 day",$timestamp);
			$dayafter = strtotime("+1 day",$timestamp);
			// On affiche			
			
			$toDisplay .= "<h3>".$this->convert_day(date("N",$timestamp))." ".date("d",$timestamp)." ".$this->convert_months(date("m",$timestamp))." ".date("Y",$timestamp)."</h3>\n"; //d/m/Y
			$toDisplay .= "<p><img src='graph.php?day=".$_GET['day']."&amp;size=small' alt='' width='650' height='150' /></p>\n";
		}
		else {
			$result =$GLOBALS['SQL']->query($GLOBALS['SQL']->rq_getLast24());
			$data = new DataStruct();
			$data->buildFromSQLResult($result,true);
	  		$toDisplay = "<h3>".I10N_LAST24."</h3>\n";
			$toDisplay .= "<p><img src='graph.php?last24=1&amp;size=small' alt='' width='650' height='150' /></p>\n";
			
		}
		
		$toDisplay .= "<p style='border-bottom:1px solid #cccccc;'>&nbsp;</p>\n";
		/* DEBUT ANALYSE */
		
		$toDisplay .= "<p style='text-decoration:underline; font-size:14px;font-weight:bold;'>".I10N_ANALYSE."</p>\n";	 
		$toDisplay .= "<table cellpadding='0' cellspacing='0' border='0' style='text-align:left; width:500px; margin-left:auto;margin-right:auto;'>\n";
		// QoL
		$toDisplay .= "<tr>\n";
		$toDisplay .= "<td>\n";
		$toDisplay .= "<p>";
		$toDisplay .= "<img src='".Analyseur::toGif(Analyseur::QoL($data->getSNRMoyenne()))."' style='width:22px; height:10px;' alt='' />";
		$toDisplay .= "<span style='font-size:13px;font-weight:bold; margin-left:5px;'>".I10N_QOL."</span>";
		$toDisplay .= "</p>\n";		
		$toDisplay .= "<p style='margin-left:15px;'>".Analyseur::QoL_comment($data->getSNRMoyenne())."</p>";
		$toDisplay .= "</td>\n";
		$toDisplay .= "</tr>\n";
		// Fin QoL
		
		// Debit
		$toDisplay .= "<tr>\n";
		$toDisplay .= "<td>\n";
		$toDisplay .= "<p>";
		$toDisplay .= "<img src='".Analyseur::toGif(Analyseur::Debit($data->getAttenuationMoyenne()))."' style='width:22px; height:10px;' alt='' />";
		$toDisplay .= "<span style='font-size:13px;font-weight:bold; margin-left:5px;'>".I10N_DEBIT."</span>";
		$toDisplay .= "</p>\n";
		$toDisplay .= "<p style='margin-left:15px;'>".Analyseur::Debit_comment($data->getAttenuationMoyenne())."</p>";
		$toDisplay .= "</td>\n";
		$toDisplay .= "</tr>\n";
		// Fin Debit
			
		$toDisplay .= "</table>\n";
		/*FIN ANALYSE  */
		$toDisplay .= "<p style='border-bottom:1px solid #cccccc;'>&nbsp;</p>\n";
		
		if(isset($_GET['day'])) {
			$toDisplay .= "<p><a href='?rub=day&amp;day=".date("Y-m-d",$daybefore)."'>".I10N_DAY_BEFORE."</a>";	
			$toDisplay .= " - ";			
			$toDisplay .= "<a href='?rub=day&amp;day=".date("Y-m-d",$dayafter)."'>".I10N_DAY_AFTER."</a></p>";
		}
		else {
			$toDisplay .= "<p><a href='?rub=week&amp;week=".date('W')."&amp;year=".date('Y')."'>".I10N_ALL_WEEK."</a></p>\n";
		}

		return $toDisplay;
	}
	  
	public function prepare() {
	  	return "";	  
	}


}
?>